# coding: utf-8
'''
Created on 11 февр. 2016 г.

@author: popov_v
'''
from nci import generalSettings
from suds.client import Client
from edu._edu_orm import accred_cycle_requestCursor
from medstaff._medstaff_orm import accreditation_cycleCursor
import uuid
from webservices.functions import uploadCursor

def createAccredCycleFromRequest(context, request_id):
    u'''Функция создания аккредитационного цикла из заявки на ИЦА.
    К заявке должно быть прикреплено ФЛ + указана обязательная инфа про КДПП, доки и пр. '''
    
    accred_cycle_request = accred_cycle_requestCursor(context)
    accred_cycle_request.get(request_id)
    
    # получаем общие настройки
    _generalSettings = generalSettings.getSettingsJSON()
    
    accreditation_cycle = accreditation_cycleCursor(context)
    accreditation_cycle.uid = uuid.uuid4()
    accreditation_cycle.person_id = accred_cycle_request.person_id
    accreditation_cycle.complex_program_id = accred_cycle_request.complex_program_id
    accreditation_cycle.umk_version_id = accred_cycle_request.umk_version_id
    accreditation_cycle.specialization_id = accred_cycle_request.specialization_id
    accreditation_cycle.startdate = accred_cycle_request.startdate
    accreditation_cycle.enddate = accred_cycle_request.enddate
    accreditation_cycle.edu_organization_id = accred_cycle_request.edu_organization_id
    accreditation_cycle.status_id = 0
    accreditation_cycle.last_issue_date = accred_cycle_request.last_issue_date
    accreditation_cycle.last_doc_series = accred_cycle_request.last_doc_series
    accreditation_cycle.last_doc_number = accred_cycle_request.last_doc_number
    accreditation_cycle.last_doc_organization = accred_cycle_request.last_doc_organization
    #if _generalSettings['configuration'] == 'full':
        # работа локально
    accreditation_cycle.insert()
    ### ЗАКОММЕНТИРОВАНО до решения вопроса с мульти-мастре Postges кластером ####
    ''''elif _generalSettings['configuration'] == 'management':
        # выбираем список веб-сервисов с конфигурацией medstaff
        msWs = _generalSettings['webServiceSettings']['medstaff']
        for ws in msWs:
            # отправляем данные в каждую систему
            uploadCursor(context, accreditation_cycle, 'medstaff', 'accreditation_cycle',
                          ws['systemName'], ws['userPin'],  ws['wsUrl'], filteredCursor=False)
    '''
    # обновляем заявку - указываем идентификатор ИЦА
    accred_cycle_request.accred_cycle_id = accreditation_cycle.uid
    accred_cycle_request.update() 

    
def changeAccredCycleStatusFromRequest(context, request_id, status_id):
    u'''Функция изменения статуса аккредитационного цикла из заявки на ИЦА.'''
    
    accred_cycle_request = accred_cycle_requestCursor(context)
    accred_cycle_request.get(request_id)
    
    # получаем общие настройки
    _generalSettings = generalSettings.getSettingsJSON()
        
    accreditation_cycle = accreditation_cycleCursor(context)
    accreditation_cycle.get(accred_cycle_request.accred_cycle_id)
    accreditation_cycle.status_id = status_id
    #if _generalSettings['configuration'] == 'full':
    #    # работа локально
    accreditation_cycle.update()
    ### ЗАКОММЕНТИРОВАНО до решения вопроса с мульти-мастре Postges кластером ####
    '''elif _generalSettings['configuration'] == 'management':
        # выбираем список веб-сервисов с конфигурацией medstaff
        msWs = _generalSettings['webServiceSettings']['medstaff']
        for ws in msWs:
            # отправляем данные в каждую систему
            uploadCursor(context, accreditation_cycle, 'medstaff', 'accreditation_cycle',
                          ws['systemName'], ws['userPin'],  ws['wsUrl'], filteredCursor=False)
    '''